######################## begin conf ########################
FTP_HOST = 'ftp.tripod.com'
FTP_USER = 'rawfish7'
FTP_TARGET_PATH = '' # e.g. 'public_html/'. If not empty, REMEMBER TO ADD THE TRAILING /

# list of directories (under current directory) each containing config
# and templates for a a different setup (e.g. html and wml, his and hers, etc.)
# dogwalker simply runs "rawdog -uvwd dir" for each dir in this list
CONF_DIRS = ['htmlconf','wmlconf']

# Output filenames we have to ftp-upload (they're actually defined inside the config
# files of the conf directory, but I'm too lazy to write the extra code)
# also - we don't need to upload the css EACH time, but what the heck?
FTP_FILES = ['rawdog.html','rawdog.wml','rawdog.css']
UPDATE_EVERY_SECONDS = 60*20 # 20 minutes

### ftp tweaking (you probably don't need to touch these)
# Only people behind SOME firewalls need ftp to be passive
#FTP_PASSIVE = 0
# But it sure wouldn't hurt ;)
FTP_PASSIVE = 1

# Don't change port unless you're really weird
FTP_PORT = 21
######################## end conf ########################
import ftplib,getpass,time,os,sys,traceback

def walk_dog(conf_dir):
    "a wrapper to run rawdog in a config dir, and then chdir back to where we were"
    from rawdoglib.rawdog import main
    d=os.getcwd()
    try:
        main(['-uvwd',conf_dir])
    finally:
        os.chdir(d)

def tell(msg):
    print '%s: %s' % (time.strftime('%Y-%m-%d %H:%M:%S'),msg)

def tell_error(where):
    larry,curly,moe=sys.exc_info()
    print 'Error %s during %s!!!!!!!!!!!!!!!!\n"%s"' % (larry,where,curly)
    traceback.print_tb(moe)
        
FTP_PASS=None
while not FTP_PASS:
    FTP_PASS=getpass.getpass('Password for %s at %s:' % (FTP_USER,FTP_HOST))
while 1:
    for conf_dir in CONF_DIRS:
        try:
            walk_dog(conf_dir)
        except:
            tell_error('RAWDOG (%s)' % conf_dir)
    try:
        tell('connecting to %s...' % FTP_HOST)
        f=None
        while not f:
            try:
                f=ftplib.FTP(FTP_HOST,FTP_USER,FTP_PASS)
            except ftplib.error_perm: # probably a bad password
                f=None
                FTP_PASS=None
                while not FTP_PASS:
                    FTP_PASS=getpass.getpass('Invalid passsword for %s at %s!!! please reenter:' %
                                             (FTP_USER,FTP_HOST))
        if FTP_PASSIVE:
            f.makepasv()
        for filename in FTP_FILES:
            tell('sending %s->%s%s...' % (filename,FTP_TARGET_PATH,filename))
            try:
                f.storbinary('STOR %s%s' % (FTP_TARGET_PATH,filename),file(filename,'rb'))
            except:
                tell_error('FTP (sending %s)' % filename)
    except:
        tell_error('FTP')
    try: # whether succeeded of failed, let's quit nicely
        f.quit()
    except:
        pass # OK. That's nice enough ;)
    print 'Sleeping for %d seconds... (ctrl+break to abort)' % UPDATE_EVERY_SECONDS
    time.sleep(UPDATE_EVERY_SECONDS)